<?php
/***************************************************************************
*
* @package Medals Mod for phpBB3
* @version $Id: ucp_medals.php,v 1.0.0 2009/10/28 Gremlinn $
* @copyright (c) 2009 Nathan DuPra (mods@dupra.net)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
***************************************************************************/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* ucp_medals
* UCP Medals Panel
* @package ucp
*/
class ucp_medals
{
	var $u_action;
	var $new_config;
	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template, $phpbb_root_path, $phpEx;
	  
		$sql = "SELECT *
			FROM " . MEDALS_TABLE . "
			ORDER BY order_id ASC";
		$result = $db->sql_query($sql);
		$medals = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$medals[$row['id']] = array( 
				'name' 			=> $row['name'], 
				'image'	 		=> $phpbb_root_path . 'images/medals/' . $row['image'],
				'device' 		=> $phpbb_root_path . 'images/medals/devices/' . $row['device'],
				'dynamic'		=> $row['dynamic'],
				'parent' 		=> $row['parent'], 
				'id'			=> $row['id'],
				'number'		=> $row['number'],
				'nominated'		=> $row['nominated'],
				'order_id'		=> $row['order_id'],
				'description'	=> $row['description'],
				'points'		=> $row['points'],
			);
		}
		$db->sql_freeresult($result);

		$sql = "SELECT *
			FROM " . MEDALS_CATS_TABLE . "
			ORDER BY order_id ASC";
		$result = $db->sql_query($sql);
		$cats = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$cats[$row['id']] = array( 
				'name' 		=> $row['name'], 
				'id'		=> $row['id'],
				'order_id'	=> $row['order_id'],
			);
			$template->assign_block_vars('catlinkrow', array(
										'U_CATPAGE'		=> append_sid('medals.php?cat=' . $row['id']),
										'MEDAL_CAT'		=> $row['name'],
								));
		}
		$db->sql_freeresult($result);

		include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
		include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
		include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
		generate_smilies('inline', 0);

		$user->add_lang('mods/info_medals_mod');
		$user->add_lang('posting');

		$userid			= $bitfield			= '';	// will be modified by generate_text_for_storage
		$allow_bbcode	= $allow_smilies	= true;
		$allow_urls		= false;
		$m_flags = '3';  // 1 is bbcode, 2 is smiles, 4 is urls (add together to turn on more than one)

		$config['points_enable'] = isset($config['points_enable']) ? $config['points_enable'] : 0;

		// Gather post and get variables
		$user_id     = $user->data['user_id'];
		$return_page = '<br /><br />' . sprintf($user->lang['RETURN_PAGE'], '<a href="' . $this->u_action . '">', '</a>');
		$submit		 = (!empty($_POST['submit'])) ? true : false;
		$medals_ary	 = (!empty($_POST['selected'])) ? ($_POST['selected']) : '';
		$action		 = request_var('a', '');
		$userid		 = request_var('u', '');
		$med_id		 = request_var('med', 0);
		$award_id	 = request_var('ai', '0');

		$del_list    = array();

		switch($action)
		{
			case 'delete':
			case 'delete_all':
				if ($user->data['user_type'] != USER_FOUNDER && !$auth->acl_get('u_award_medals'))
				{
					trigger_error($user->lang['NO_GOOD_PERMS']);
				}
				if (!$award_id)
				{
					trigger_error('NO_MEDAL_ID');
				}
				$pnts = ($config['points_enable'] == 1 && $mode != "manage") ? $pnts = 1 : $pnts = 0;
				$delete_all = ($action == 'delete_all') ? 1 : 0;

				delete_award($award_id, $user_id, $pnts, $delete_all);

				trigger_error($user->lang['MEDAL_REMOVE_GOOD'] . $return_page);
			break;
			
			case 'add':
				if ($user->data['user_type'] != USER_FOUNDER && !$auth->acl_get('u_award_medals'))
				{
					trigger_error($user->lang['NO_GOOD_PERMS'] . $return_page);
				}
				if ( $submit )
				{
					if (!$med_id)
					{
						trigger_error('NO_MEDAL_ID' . $return_page);
					}
					
					$message	= utf8_normalize_nfc(request_var('message', ''), '', true);
					if (!strlen($message))
					{
						trigger_error(sprintf($user->lang['NO_MEDAL_MSG'] . $return_page));
					}

					$award_user = $not_award_user = $awarded_user = $no_such_user = array() ;

					// Call award_medal function
					$time = time() ;
					award_medal($med_id, $userid, request_var('message', ''), $time, $medals[$med_id]['points']) ;
					trigger_error($user->lang['MEDAL_AWARD_GOOD'] . $return_page);
				}

			break;
			
			case 'approve':
				if ($user->data['user_type'] != USER_FOUNDER && !$auth->acl_get('u_award_medals'))
				{
					trigger_error($user->lang['NO_GOOD_PERMS']);
				}
				if (!$med_id )
				{
					trigger_error('NO_MEDAL_ID');
				}

				$sql = "SELECT count(*) as count
						FROM " . MEDALS_AWARDED_TABLE . "
						WHERE medal_id = {$med_id}
						  AND user_id = {$user_id}
						  AND nominated = 0" ;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if ( $row['count'] >= $medals[$med_id]['number'] )
				{
					trigger_error($user->lang['CANNOT_AWARD_MULTIPLE'] . $return_page);
				}

				$sql = "SELECT *
						FROM " . MEDALS_AWARDED_TABLE . "
						WHERE id = {$award_id}" ;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				$message = (request_var('message', '')) ? request_var('message', '') : $row['nominated_reason'];
				$message = generate_text_for_edit($message,$row['bbuid'],$m_flags);
				award_medal($row['medal_id'], $row['user_id'], $message['text'], $row['time'], $medals[$med_id]['points'], $row['id']) ;
				trigger_error($user->lang['MEDAL_AWARD_GOOD'] . $return_page);
			break;

			case 'edit':
				$mode='award';
			break;
		}

		switch($mode)
		{
			case 'award':
				$this->page_title = $user->lang['AWARD_MEDAL'];
				$this->tpl_name = 'ucp_medals_award_user';

				if ($user->data['user_type'] != USER_FOUNDER && !$auth->acl_get('u_award_medals'))
				{
					trigger_error($user->lang['NO_GOOD_PERMS']);
				}
				if ($user_id == 0 || $user_id == ANONYMOUS)
				{
					trigger_error('NO_USER_ID');
				}
				$sql = "SELECT *
						FROM " . MEDALS_AWARDED_TABLE . "
						WHERE user_id = {$user_id}
						ORDER BY medal_id AND nominated";
				$result = $db->sql_query($sql);
				$my_medals = array();
				while ($row = $db->sql_fetchrow($result))
				{
					if ( isset($my_medals[$row['medal_id']]['count']) )
					{
						$row['count'] = $my_medals[$row['medal_id']]['count'] + '1';
					}
					else
					{
						$row['count'] = '1';
					}
					$my_medals[$row['medal_id']] = $row;
				}
				$db->sql_freeresult($result);
				
				$sql = "SELECT user_id, username, user_colour
					FROM " . USERS_TABLE . "
					WHERE user_id = {$user_id}";
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				
				$username = get_username_string('full', $row['user_id'], $row['username'], $row['user_colour'], $row['username']);

				$medals_options = '<option value=""></option>';
				$temp_string = '';
				$no_medals = true ;
				foreach ($cats as $key => $value)
				{
					$at_least_one = false;
					foreach ($medals as $key2 => $value2)
					{
						if ($value2['parent'] == $value['id'])
						{
							$can_award = false;
							$my_medals[$value2['id']]['count'] = isset($my_medals[$value2['id']]['count']) ? $my_medals[$value2['id']]['count'] : 0;
							if ( $my_medals[$value2['id']]['count'] < $value2['number'] || $medal_id == $value2['id'] )
							{
								$my_medals[$value2['id']]['nominated'] = isset($my_medals[$value2['id']]['nominated']) ? $my_medals[$value2['id']]['nominated'] : 0;
								if (isset($my_medals[$value2['id']]) && $my_medals[$value2['id']]['nominated'] == 1)
								{
									$value2['name'] .= ' ' . sprintf($user->lang['NOMINATED_BY'], $my_medals[$value2['id']]['awarder_un']);
								}
								else if ( $value2['nominated'] )
								{
									$value2['name'] .= ' ' . $user->lang['NOMINATABLE'];
								}
								if ( $med_id == $value2['id'] )
								{
									$temp_string .= '<option value="' . $value2['id'] . '" selected="selected">&bull;&nbsp;' . $value2['name'] . '</option>';
									$message = generate_text_for_edit($my_medals[$value2['id']]['nominated_reason'],$my_medals[$value2['id']]['bbuid'],$m_flags);
									$medal_edit = "&ai=" . $award_id . "&med=" . $med_id ;
								}
								else
								{
									$temp_string .= '<option value="' . $value2['id'] . '">&bull;&nbsp;' . $value2['name'] . '</option>';
								}
								$at_least_one = true;
							}
						}
					}
					if ($at_least_one)
					{
						$medals_options .= '<option value="">' . $value['name'] . '</option>';
						$medals_options .= $temp_string;
						$at_least_one = false;
						$temp_string = '';
						$no_medals = false ;
					}
				}
			
				$medals_arr       = 'var medals = new Array();';
				$medals_desc_arr  = 'var medals_desc = new Array();' ;
				foreach ($medals as $key => $value)
				{
					$medals_arr .= 'medals[' . $value['id'] . '] = "' . $value['image'] . '";';
					$medals_desc_arr .= 'medals_desc[' . $value['id'] . '] = "' . $value['description'] . '";';
				}
				$medals_arr .= "\n" . $medals_desc_arr . "\n" ;
				
				if ($no_medals)
				{
					$medals_options = '<option value="">' . $user->lang['NO_MEDALS'] . '</option>';
				}

				$bbcode_status	= ($config['allow_bbcode']) ? true : false;
				$smilies_status	= ($bbcode_status && $config['allow_smilies']) ? true : false;
				$img_status		= ($bbcode_status) ? true : false;
				$url_status		= ($bbcode_status && $config['allow_post_links']) ? true : false;
				$flash_status	= ($bbcode_status) ? true : false;
				$quote_status	= ($bbcode_status) ? true : false;
				display_custom_bbcodes();

				$message = isset($message['text']) ? $message['text'] : '';
				$template->assign_vars(array(
					'USERNAME'				=> $username,
					'MEDALS'				=> $medals_options,
					'JS'					=> $medals_arr,

					'S_MEDALS_UCP'			=> true,
					'U_MEDALS_ACTION'		=> isset($medal_edit) ? $this->u_action . '&a=approve&u=' . $user_id . $medal_edit : $this->u_action . '&a=add&u=' . $user_id,
					'MESSAGE'				=> $message,

					'S_BBCODE_ALLOWED'		=> $bbcode_status,
					'S_BBCODE_IMG'			=> $img_status,
					'S_BBCODE_URL'			=> $url_status,
					'S_BBCODE_FLASH'		=> $flash_status,
					'S_BBCODE_QUOTE'		=> $quote_status,
				));
			break;

			case 'manage':
				$this->page_title = $user->lang['NOMINATE_MEDAL'];
				$this->tpl_name = 'ucp_medals_nominate_user';

				if ($user->data['user_type'] != USER_FOUNDER && !$auth->acl_get('u_award_medals'))
				{
					trigger_error($user->lang['NO_GOOD_PERMS']);
				}
				$sql = 'SELECT user_id, username, user_colour
						FROM ' . USERS_TABLE . "
						WHERE user_id = {$user_id}";
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);
				$username = get_username_string('full', $row['user_id'], $row['username'], $row['user_colour'], $row['username']);
				
				$sql = "SELECT ma.*, m.name
						FROM " . MEDALS_AWARDED_TABLE . " as ma, " . MEDALS_TABLE . " as m
						WHERE ma.user_id = {$user_id}
						  AND ma.medal_id = m.id
						  AND ma.nominated <> 0";
				$result = $db->sql_query($sql);
				$i = 0;
				while ($row = $db->sql_fetchrow($result))
				{
					$awarder_name = get_username_string('full', $row['awarder_id'], $row['awarder_un'], $row['awarder_color'], $row['awarder_un']) ;
					$nom_message = sprintf($user->lang['NOMINATE_MESSAGE'], $awarder_name, $row['name']);

					// Parse the message and subject
					$message = generate_text_for_display($row['nominated_reason'], $row['bbuid'], $row['bitfield'], $m_flags);
					$message = $nom_message . $message ;
					$message = censor_text($message);
				
					$message = str_replace("\n", '<br />', $message);

					$userid = $row['bbuid'];
					$bitfield = $row['bitfield'];

					$template->assign_block_vars('nominations', array(
						'USERNAME'	=> $awarder_name,
						'REASON'	=> $message,
						'U_DELETE'		=> $this->u_action . '&a=delete&u=' . $user_id . '&ai=' . $row['id'],
						'U_APPROVE'		=> $this->u_action . '&a=approve&u=' . $user_id . '&ai=' . $row['id'] . '&med=' . $row['medal_id'],
						'U_MEDAL_EDIT'	=> $this->u_action . '&a=edit&' . 'ai=' . $row['id'] . '&med=' . $row['medal_id'],
					));
					$i++;
					$del_list[] = "'".$row['id']."'";
				}
				$db->sql_freeresult($result);
				
				$template->assign_vars(array(
					'U_MEDALS_ACTION'		=> append_sid('includes/ucp_medals.php?m=submit&u=' . $user_id),
					'NOMINATE_MEDAL'		=> sprintf($user->lang['NOMINATE_USER_LOG'] , $username),
					'S_ROW_COUNT'			=> $i,
					'U_DELETE_ALL'	=> (count($del_list) > 0) ? $this->u_action . '&a=delete_all&u=' . $user_id . '&ai=' . implode(",",$del_list) : false,
				));
			break;

			default:
				$this->page_title = $user->lang['AWARDED_MEDAL_TO'];
				$this->tpl_name = 'ucp_medals_awarded_user';

				$sql = "SELECT user_id, username, user_colour
					FROM " . USERS_TABLE . "
					WHERE user_id = " . $user_id;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				
				$username = get_username_string('full', $row['user_id'], $row['username'], $row['user_colour'], $row['username']);
					
				$sql3 = "SELECT *
						FROM " . MEDALS_AWARDED_TABLE . "
						WHERE user_id = " . $user_id . "
							AND nominated <> 1" ;
				$result3 = $db->sql_query($sql3);
				$s_medals = false;
				$users_medals = array();
				while ($row3 = $db->sql_fetchrow($result3))
				{
					$awarder_name = get_username_string('full', $row3['awarder_id'], $row3['awarder_un'], $row3['awarder_color'], $row3['awarder_un']) ;
					$nom_message = sprintf($user->lang['NOMINATE_MESSAGE'], $awarder_name, $medals[$row3['medal_id']]['name']);

					// Parse the message and subject
					$reason = generate_text_for_display($row3['nominated_reason'], $row3['bbuid'], $row3['bitfield'], $m_flags);
					$message = $user->lang['AWARDED_BY'] . ' ' . $awarder_name . ' ' . $user->format_date($row3['time']) . '<br \>' . $reason ;

					$this_cat = $cats[$medals[$row3['medal_id']]['parent']];
					$users_medals[$this_cat['order_id']]['name'] = $this_cat['name'];
					$users_medals[$this_cat['order_id']][$medals[$row3['medal_id']]['order_id']][] = array(
						'MEDAL_NAME'		=> $medals[$row3['medal_id']]['name'],
						'MEDAL_IMAGE'		=> '<img src="' . $phpbb_root_path . $medals[$row3['medal_id']]['image'] . '" title="' . $medals[$row3['medal_id']]['name'] . '" alt="' . $medals[$row3['medal_id']]['name'] . '" />',
						'MEDAL_REASON'		=> $message,
						'ID'				=> $row3['id'],
					);
					$s_medals = true;
				}
				$db->sql_freeresult($result3);
				
				$my_medals_arr = array();
				ksort($users_medals);
				foreach ($users_medals as $key => $value)
				{
					ksort($value);
					foreach ($value as $key2 => $value2)
					{
						if ($key2 != 'name')
						{
							foreach ($value2 as $key3 => $value3)
							{
								$my_medals_arr[] = array($value3, false);
							}
						}
						else
						{
							$my_medals_arr[] = array($value2, true);
						}
					}
				}

				foreach ($my_medals_arr as $key => $value)
				{
					if ($value[1])
					{
						$template->assign_block_vars('medals', array(
							'MEDAL_NAME'		=> $value[0],
							'IS_CAT'			=> true,
						));
					}
					else
					{
						$template->assign_block_vars('medals', array(
							'MEDAL_NAME'		=> $value[0]['MEDAL_NAME'],
							'MEDAL_IMAGE'		=> $value[0]['MEDAL_IMAGE'],
							'MEDAL_REASON'		=> $value[0]['MEDAL_REASON'],
							'MEDAL_ID'			=> $value[0]['ID'],
							'U_DELETE'			=> $this->u_action . '&a=delete&u=' . $user_id . '&ai=' . $value[0]['ID'],

							'IS_CAT'			=> false,
						));
						$del_list[] = "'".$value[0]['ID']."'";
					}
				}
					
				$template->assign_vars(array(
					'USERNAME'				=> $username,
					'U_DELETE_ALL'	=> (count($del_list) > 0) ? $this->u_action . '&a=delete_all&u=' . $user_id . '&ai=' . implode(",",$del_list) : false,
				));
			break;
		}
	}
} 

function award_medal($medal_id, $user_id, $message, $time, $points = 0, $update = 0)
{
	global $db, $user, $config, $phpbb_root_path, $phpEx, $table_prefix, $medals ;
	global $allow_bbcode, $allow_urls, $allow_smilies, $m_flags ;

	$allow_bbcode	= $allow_smilies	= true;
	$allow_urls		= false;
	$m_flags = '3';  // 1 is bbcode, 2 is smiles, 4 is urls (add together to turn on more than one)

	generate_text_for_storage($message, $userid, $bitfield, $m_flags, $allow_bbcode, $allow_urls, $allow_smilies);
	
	if ( $update > 0 )
	{
		$sql_ary = array(
			'medal_id'		=> $medal_id,
			'user_id'		=> $user_id,
			'nominated'		=> 0,
			'nominated_reason'	=> $message,
			'points'		=> $points,
			'time'			=> $time,
			'bitfield'		=> $bitfield,
			'bbuid'			=> $userid,
		);

		$sql = "UPDATE " . MEDALS_AWARDED_TABLE . " SET " . $db->sql_build_array('UPDATE', $sql_ary) . "
				WHERE id = {$update}
				LIMIT 1";
		$db->sql_query($sql);

		$sql = "SELECT awarder_id, awarder_un, awarder_color
				FROM " . MEDALS_AWARDED_TABLE . "
				WHERE id = {$update}
				LIMIT 1";

		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		
		$color = $row['awarder_color'] <> "" ? '[color=#' . $row['awarder_color'] . ']' . $row['awarder_un'] . '[/color]': $row['awarder_un'] ;
	}
	else
	{
		$sql_ary = array(
			'medal_id'		=> $medal_id,
			'user_id'		=> $user_id,
			'awarder_id'	=> $user->data['user_id'],
			'awarder_un'	=> $user->data['username'],
			'awarder_color'	=> $user->data['user_colour'],
			'nominated'		=> 0,
			'nominated_reason'	=> $message,
			'points'		=> $points,
			'time'			=> $time,
			'bitfield'		=> $bitfield,
			'bbuid'			=> $userid,
		);

		$sql = "INSERT INTO " . MEDALS_AWARDED_TABLE . " " . $db->sql_build_array('INSERT', $sql_ary);
		
		$color = $user->data['user_colour'] ? '[color=#' . $user->data['user_colour'] . ']' . $user->data['username'] . '[/color]': $user->data['username'] ;
	}
	$result = $db->sql_query($sql);

	$message = generate_text_for_edit($message,$userid,$m_flags);
	$message = isset($message['text']) ? $message['text'] : '';

	if ($result && $config['points_enable'] == 1)
	{
		$sql = "UPDATE " . USERS_TABLE . " 
					SET user_points = user_points + $points
					WHERE user_id = $user_id" ;
		$db->sql_query($sql);
	}

	$message2  = sprintf($user->lang['PM_MESSAGE'], '[img]' . generate_board_url() . '/' . $medals[$medal_id]['image'] . '[/img]', $medals[$medal_id]['name'], $color );
	$message2  .= $message;
	if ( $config['points_enable'] == 1 )
	{
		if ( $points < 0 )
		{
			$plural = $points < -1 ? 's' : '';
			$message2 .= sprintf($user->lang['PM_MESSAGE_POINTS_DEDUCT'], $points * -1, $plural);
		}
		else if ( $points > 0 )
		{
			$plural = $points > 1 ? 's' : '';
			$message2 .= sprintf($user->lang['PM_MESSAGE_POINTS_EARN'], $points, $plural);
		}
	}

	generate_text_for_storage($message2, $userid, $bitfield, $m_flags, $allow_bbcode, $allow_urls, $allow_smilies);

	$user->add_lang('ucp');

	include_once($phpbb_root_path . 'includes/functions_privmsgs.' . $phpEx);
		
	$pm_data = array(
		'address_list'		=> array('u' => array($user_id => 'to')),
		'from_user_id'		=> $user->data['user_id'],
		'from_user_ip'		=> $user->data['user_ip'],
		'from_username'		=> $user->data['username'],
		'enable_sig'		=> false,
		'enable_bbcode'		=> $allow_bbcode,
		'enable_smilies'	=> $allow_smilies,
		'enable_urls'		=> $allow_urls,
		'icon_id'			=> 0,
		'bbcode_bitfield'	=> $bitfield,
		'bbcode_uid'		=> $userid,
		'message'			=> $message2,
	);
	
	$subject = sprintf($user->lang['PM_MSG_SUBJECT'], $user->data['username']);

	submit_pm('post', $subject, $pm_data, false);
	
	return;
}

function delete_award($aid, $uid, $pnts=0, $del=0)
{
	global $db, $user, $config, $phpbb_root_path, $phpEx, $table_prefix, $medals ;
	global $allow_bbcode, $allow_urls, $allow_smilies, $m_flags ;
	$points = 0;

	if ($config['points_enable'] == 1 && $pnts != 0)
	{
		$sql = "SELECT points
				FROM " . MEDALS_AWARDED_TABLE . '
				WHERE id in (' . $aid . ')';
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		foreach ( $row as $key => $value )
		{
			$points = $points + $value['points'];
		}

		$sql = "UPDATE " . USERS_TABLE . " 
					SET user_points = user_points - " . $points . "
					WHERE user_id = " . $uid ;
		$db->sql_query($sql);
	}

	$sql = "DELETE FROM " . MEDALS_AWARDED_TABLE . '
				WHERE id in (' . $aid . ')';
	$db->sql_query($sql);

	return;
}
?>